;Include "maps.bb"

Graphics 640,480,0,2

SetBuffer BackBuffer()

SeedRnd MilliSecs()

Const Length = 15
Const Width = 20
Const MaxLength = 999
Const NumTiles = 9
Const NumLevels = 1
Const NumEnemies = 99

Dim Tile(NumTiles)
Dim MapImg(NumLevels)

Tile(0) = LoadImage("tile0.bmp")
Tile(1) = LoadImage("tile1.bmp")
Tile(2) = LoadImage("tile2.bmp")
Tile(3) = LoadImage("tile3.bmp")
Global Ship = LoadImage("ship1.bmp")
Global Enemy = LoadImage("target.bmp")
Global Bang = LoadAnimImage("exp1.bmp",32,32,0,4)
MapImg(1) = LoadImage("map1.bmp")
MaskImage Ship,255,255,255


Global YScroller = 0
Global SwitchRows = False
Global MapLength = Length

Dim Map(Width-1,MaxLength)

;Restore Level1
;Read MapLength
;For j = 0 To MapLength-1
;	For i = 0 To Width-1
;		Read Map(i,j)
;	Next
;Next

Type Cell
	Field Index
	Field Tile
	Field Spawn
	Field Row
	Field Col
	Field MapRow
	Field YValue
End Type

Dim Row.Cell(Width-1,Length)

For j = 0 To Length
	For i = 0 To Width-1
		k = i + (20*j)
		Row.Cell(i,j) = New Cell
		Row(i,j)\Index = k
		Row(i,j)\Row = j
		Row(i,j)\Col = i
		Row(i,j)\MapRow = Row(i,j)\Row
		Row(i,j)\YValue = YScroller + 480 - ((Row(i,j)\Row + 1) * 32)
		Row(i,j)\Tile = Map(i,Row(i,j)\MapRow) ; here is where we address each line shown on screen
	Next
Next

Type Player
	Field X,Y
	Field Row,Col
	Field HP
End Type

Global Player1.Player = New Player
Player1\X = 320
Player1\Y = 400

Dim Badguy.Player(NumEnemies)

For i = 0 To NumEnemies
	Badguy.Player(i) = New Player
Next

Global BadguyCount = 0

game_timer = CreateTimer(60)

HidePointer

LoadMap(1)



While Not KeyHit(1)

	WaitTimer(game_timer)
	
	UpdateRows()

	Cls

	For j = 0 To Length
		For i = 0 To Width-1
			k = i + (20*j)
			DrawImage Tile(Row(i,j)\Tile),32*i,Row(i,j)\YValue
			;Text 32*i,Row(i,j)\YValue,Row(i,j)\MapRow	; debug text
		Next
	Next
	
	GetInput()
	UpdateShips()
	
	DrawImage Ship,Player1\X-16,Player1\Y-16
	
	Flip

Wend

	For i = 0 To NumTiles
		FreeImage Tile(i)
	Next
	For i = 0 To NumLevels
		FreeImage MapImg(i)
	Next
	FreeImage Ship
	FreeImage Enemy
	FreeImage Bang

End

;

Function GetInput()

	xs=MouseXSpeed() ; see how far the mouse has been moved 
	ys=MouseYSpeed() 
	MoveMouse 320,240 ;put the mouse back in the middle of the screen 

	Player1\X = Player1\X + xs/2
	Player1\Y = Player1\Y + ys/2

	If Player1\X>GraphicsWidth() Then Player1\X=GraphicsWidth() ;wrap screen 
	If Player1\X<0 Then Player1\X=0
	If Player1\Y<0 Then Player1\Y=0 
	If Player1\Y>GraphicsHeight() Then Player1\Y=GraphicsHeight()
	
	If MouseDown(1) Then Shoot(Player1)

End Function


Function UpdateShips()

	For i = 0 To BadguyCount
		;If Row(0,0)\Row = Badguy(i)\Row Then
		;	Spawn(Badguy(i))
		;EndIf
		;If Badguy(i)\Visible = True Then
			Badguy(i)\X = Badguy(i)\Col * 32
			Badguy(i)\Y = 480 - Badguy(i)\Row * 32 + YScroller
			DrawImage Enemy, Badguy(i)\X, Badguy(i)\Y
		;EndIf
	Next

End Function


Function Shoot(P.Player)

	Color Rand(200),50,50
	Line P\X+Rand(-10,-6),P\Y,P\X+Rand(-10,-6),0
	Line P\X+Rand(6,10),P\Y,P\X+Rand(6,10),0

End Function


Function UpdateRows()

	SwitchRows = False
	YScroller = YScroller + 1

	If YScroller > 32 Then
		YScroller = YScroller - 32
		SwitchRows = True
		For i = 0 To NumEnemies
			BadGuy(i)\Row = Badguy(i)\Row - 1
		Next
	EndIf
	
	For j = 0 To Length
		For i = 0 To Width-1
			If SwitchRows = True Then
				Row(i,j)\MapRow = Row(i,j)\MapRow + 1
				If Row(i,j)\MapRow = MaxLength Then Row(i,j)\MapRow = 0 ; loop map to stay in array bounds
			EndIf
			Row(i,j)\YValue = YScroller + 480 - ((Row(i,j)\Row + 1) * 32)
			Row(i,j)\Tile = Map(i,Row(i,j)\MapRow) ; here is where we address each line shown on screen
		Next
	Next

End Function


Function LoadMap(Level=1)
	
	LockBuffer ImageBuffer(MapImg(Level))

	For j = 0 To 100
		For i = 0 To 20
			a = ReadPixelFast(i,100-j,ImageBuffer(MapImg(Level)))
			r = GetR(a)
			g = GetG(a)
			b = GetB(a)
			If r = 255 And g = 255 And b = 255 Then Map(i,j) = 0
			If r = 0 And g = 255 And b = 0 Then Map(i,j) = 2
			If r = 0 And g = 0 And b = 255 Then Map(i,j) = 1
			If r = 0 And g = 0 And b = 0 Then Map(i,j) = 3
		Next
	Next
	
	For j = 0 To 100
		For i = 21 To 39
			a = ReadPixelFast(i,100-j,ImageBuffer(MapImg(Level)))
			r = GetR(a)
			g = GetG(a)
			b = GetB(a)
			If r = 0 And g = 0 And b = 0 Then AddEnemy(i-21,j)
		Next
	Next
	
	UnlockBuffer ImageBuffer(MapImg(Level))
	
End Function


Function AddEnemy(i,j)
	C = BadguyCount
	BadguyCount = BadguyCount + 1
	Badguy(C)\Row = j
	Badguy(C)\Col = i
End Function


Function Spawn(P.Player)
	;P\Visible = True
End Function


Function Kill(P.Player)
	;P\Visible = False
End Function


Function GetR(rgb)
    Return rgb Shr 16 And %11111111
End Function


Function GetG(rgb)
	Return rgb Shr 8 And %11111111
End Function


Function GetB(rgb)
	Return rgb And %11111111
End Function

;